//import 'package:http/http.dart' as http;
import 'dart:io';
import 'package:archive/archive.dart';
import 'package:path/path.dart' show dirname, join;
import 'package:process_run/shell.dart';

main() async {
  var url =
      "http://yx-web.nos.netease.com/package/1635305057/NIM_CrossPlatform_SDK_v8.7.3.zip";

  var tmpdir = join(dirname(Platform.script.path), '../nim_sdk');
  if (Platform.isWindows) {
    tmpdir = tmpdir.substring(1, tmpdir.length);
  }

  var sdkFile = "nim_sdk.zip";
  var sdk = tmpdir + "/" + sdkFile;

  if (File(sdk).existsSync()) {
    print("[downloadSDK]: sdk existing.");
    return;
  }

  await Directory(tmpdir).create(recursive: true);

  print("[downloadSDK]: start download sdk from $url.");
  final request = await HttpClient().getUrl(Uri.parse(url));
  final response = await request.close();
  await response.pipe(File(sdk).openWrite());
  print("[downloadSDK]: download the end.");

  print("[downloadSDK]: start decompressing.");
  var sdkPlatFile = "";
  final bytes = new File(sdk).readAsBytesSync();
  final archive = new ZipDecoder().decodeBytes(bytes);
  for (var file in archive) {
    final filename = '${file.name}';
    if (file.isFile) {
      if ((Platform.isMacOS && filename.contains('macosx')) ||
          (Platform.isWindows &&
              filename.contains('windows') &&
              filename.contains('x64'))) {
      } else {
        continue;
      }

      sdkPlatFile = tmpdir + '/' + filename;
      var outFile = new File(sdkPlatFile);
      outFile = await outFile.create(recursive: true);
      await outFile.writeAsBytes(file.content);
    } else {
      await new Directory(tmpdir + '/' + filename).create(recursive: true);
    }
  }

  if (!sdkPlatFile.isEmpty) {
    if (Platform.isWindows) {
      print("[downloadSDK]: decompressing $sdkPlatFile.");
      final bytesTmp = new File(sdkPlatFile).readAsBytesSync();
      final archiveTmpData = new GZipDecoder().decodeBytes(bytesTmp);
      final archiveTmp = new TarDecoder().decodeBytes(archiveTmpData);
      for (var file in archiveTmp) {
        final filename = '${file.name}';
        if (file.isFile) {
          var macFile = tmpdir + '/' + filename;
          var outFile = new File(macFile);
          outFile = await outFile.create(recursive: true);
          await outFile.writeAsBytes(file.content);
        } else {
          await new Directory(tmpdir + '/' + filename).create(recursive: true);
        }
      }
    } else {
      var shell = Shell();
      shell = shell.cd(tmpdir);
      await shell.run('tar -zxf "$sdkPlatFile"');
    }

    File(sdkPlatFile).delete();
    print("[downloadSDK]: decompression end(successfull).");
  } else {
    print("[downloadSDK]: decompression end(failed).");
  }
}
